import { PostNodeBuilder, Renderer } from "mobiledoc-kit";

const getMethods = (obj: any) => {
  let properties = new Set();
  let currentObj = obj;
  do {
    Object.getOwnPropertyNames(currentObj).map((item) => properties.add(item));
  } while ((currentObj = Object.getPrototypeOf(currentObj)));
  return [...properties.keys()].filter(
    (item: any) => typeof obj[item] === "function"
  );
};

const builder = new PostNodeBuilder();
const renderer = Renderer;

const post = builder.createPost([]);
console.log(getMethods(post));
console.log(post);
console.log(post.valueOf());

function buildFromText() {
  //let renderElement = new HTMLElement();

  //let beforeRender = function () {};
  const builder = new PostNodeBuilder();
  let strong = builder.createMarkup("strong");
  let marker1 = builder.createMarker("Hi ", [strong]);
  let marker2 = builder.createMarker(" Bye", [strong]);
  let cardSection = builder.createCardSection("markdown", {
    markdown: "```js\nlet value = 0\n```",
  });
  //let atom = builder.createAtom("mention", "@bob", { id: 42 }, [strong]);
  //let section = builder.createMarkupSection("p", [marker1, atom, marker2]);
  let section = builder.createMarkupSection("p", [marker1, marker2]);
  let post = builder.createPost([section, cardSection]);
  //post.sections.append(section);
  let mobiledoc = renderer.render(post, "0.3.1");
  let editorOptions: any = {};
  editorOptions.mobiledoc = mobiledoc;
  console.log("------------------------------------");
  console.log(
    JSON.stringify({
      title: "A post",
      mobiledoc: `${JSON.stringify(mobiledoc)}`,
      status: "draft",
    })
  );
}

//const m1 = builder.createMarkup("strong");

buildFromText();
