/**
 * Load a file, parse it through markdonw-it and display its components
 */
import * as dotenv from "dotenv";
import dive from "dive";
//import { ImageProcessor } from "./convertor/ImageProcessor";
import { BlockConvertor as Convertor } from "./convertor/BlockConvertor";
import path from "node:path";
import { timer } from "./convertor/timer";
const GhostAdminAPI = require("@tryghost/admin-api");

// Init config
dotenv.config();

// Configure the client
const api = new GhostAdminAPI({
  url: process.env.BASE_URL,
  // Admin API key goes here
  key: process.env.API_KEY,
  version: process.env.API_VERSION,
});

async function main(filename: string) {
  let convertor = new Convertor(filename);
  await convertor.process(api);
  await timer(1000 * 1);
}

const extensions = [".markdown", ".md"];
dive("" + process.env.BLOGS_PATH, (err: any, file: any) => {
  if (err) throw err;
  let ext = path.extname(file).toLowerCase();
  if (extensions.includes(ext)) {
    main(file)
      .then(() => {
        console.log("OK");
      })
      .catch((r: any) => {
        throw r;
      });
  }
});
